void iogen()
{
//=========Macro describing the ROOT general I/O principles
//======== process to process, files, remote files,etc..

   gROOT->LoadMacro("object.C");

   char *slide="iogen";
   InitCanvas(slide);

   pl = new TPaveText(2,22.5,18,23.8);     
   TText *plt = pl->AddText("Object I/O: Variety of problems: Common solutions");     
   plt->SetTextFont(62);
   plt->SetTextSize(0.035);
   pl->SetFillColor(21);
   pl->Draw();

   p1 = new TPavesText(2,13,8,17,5,"tr");
   p1->SetFillColor(30);
   p1->SetBorderSize(3);
   p1->Draw();
   p2 = new TPavesText(12,13,17,17,8,"tr");
   p2->SetFillColor(30);
   p2->Draw();
   TText *tp = new TText(6,18.5,"Shared Memory");
   tp->SetTextSize(0.033);
   tp->SetTextAlign(22);
   tp->Draw();
   tp->DrawText(15,18,"MultiThreads");

   file = new TPaveText(6,5,14,9);
   file->SetFillColor(42);
   file->Draw();
   file->AddText("Object data Base");
   file->AddText("on local disks");

   rfile = new TPaveText(6,1,14,4);
   rfile->SetFillColor(42);
   rfile->Draw();
   rfile->AddText("Object data Base");
   rfile->AddText("on remote disks");

   arrow = new TArrow();
   arrow->SetLineWidth(4);
   arrow->DrawArrow(5,12.8,7.5,9.2,0.01,"<|>");
   arrow->DrawArrow(14.5,12.8,12.5,9.2,0.01,"<|>");
   arrow->DrawArrow(3.2,13,3.2,7,0.001,">");
   arrow->DrawArrow(3.2,7,5.9,7,0.01,"|>");
   arrow->DrawArrow(16,2,16,12.9,0.01,">");
   arrow->DrawArrow(14,2,16,2,0.001,">");
   arrow->DrawArrow(3.5,15.5,12.5,15.5,0.01,">");
   arrow->DrawArrow(15,15,7,15,0.01,">");

   tp->DrawText(4.5,7.5,"TFile");
   tp->DrawText(4.1,2.8,"TWebFile");
   tp->DrawText(4.1,1.8,"TNetFile");

   object(3.5,15.5,1.2);
   object(15,15,1.2);
   text = new TText();
   text->SetTextSize(0.027);
   text->DrawText(9.2,14.3,"TMessage");
   text->DrawText(9.2,13.7,"Streamer");
   text->SetTextAngle(306);
   text->DrawText(4.59538,11.9018,"Streamer");
   text->DrawText(5.63,12.2,"TBuffer");


   TText *left = new TText();
   left->SetTextSize(0.028);
   left->SetTextFont(62);
   left->SetTextColor(4);
   left->DrawText(3,21.5,"MultiThreading:");
   left->DrawText(3,21.0,"Shared Memory:");
   left->DrawText(3,20.5,"InterProcess:");
   left->DrawText(3,20.0,"Local File:");
   left->DrawText(3,19.5,"Remote File:");
   TText *rit = new TText();
   rit->SetTextSize(0.028);
   rit->SetTextFont(62);
   rit->SetTextColor(2);
   rit->DrawText(8,21.5,"Locking, banish globals and statics");
   rit->DrawText(8,21.0,"Locking");
   rit->DrawText(8,20.5,"Messaging and Client/Server");
   rit->DrawText(8,20.0,"Large Containers, Rapid Access");
   rit->DrawText(8,19.5,"Web and Remote servers");

   Signe(slide);
}
