void iomain()
{
//=========Macro describing the ROOT I/O main program
//======== and an example of header file

   char *slide="iomain";
   InitCanvas(slide);

   ptit = new TPaveLabel(6,22.7,14,23.8,"ROOT I/O  Example of C++ code");
   ptit->SetFillColor(41);
   ptit->Draw();

   header = new TPaveText(3,15,18,21);
   header->SetFillColor(17);
   header->Draw();

   t = new TText();
   t->SetTextAlign(12);
   t->SetTextSize(0.028);
   t->DrawText(5,20,"class TEvent: public TObject");
   t->SetTextColor(2);
   t->DrawText(4,19.2,"THeader");
   t->DrawText(4,18.4,"TObjArray");
   t->DrawText(4,17.6,"TClonesArray");
   t->DrawText(4,16.8,"TTOF");
   t->DrawText(4,16.0,"TCalor");
   t->SetTextColor(6);
   t->DrawText(8,19.2,"*fHeader;");
   t->DrawText(8,18.4,"*fVertex;");
   t->DrawText(8,17.6,"*fTracks;");
   t->DrawText(8,16.8,"*fTOF;");
   t->DrawText(8,16.0,"*fCalor;");
   t->SetTextColor(4);
   t->SetTextFont(72);
   t->DrawText(11,19.2,"//Event Header object");
   t->DrawText(11,18.4,"//List of vertices");
   t->DrawText(11,17.6,"//List of tracks");
   t->DrawText(11,16.8,"//Time of Flight object");
   t->DrawText(11,16.0,"//Calorimeter object");

   code = new TPaveText(2,3,18,14);
   code->SetFillColor(18);
   code->Draw();

   t->SetTextSize(0.035);
   t->SetTextFont(62);
   t->SetTextColor(1);
   t->DrawText(3,13.2,"main()");
   t->DrawText(3,12.4,"TEvent *event;");
   t->SetTextColor(4);
   t->DrawText(3,11.6,"TFile dst("demo.root","NEW");");
   t->SetTextColor(2);
   t->DrawText(3,10.8,"TTree tree("T","Example of Tree");");
   t->SetTextColor(1);
   t->DrawText(3,10.0,"Int_t split = 1;  // or split=0");
   t->SetTextColor(2);
   t->DrawText(3,9.2,"tree.Branch("event", "TEvent", @&event, split);");
   t->SetTextColor(1);
   t->DrawText(3,8.0,"for (int ev =0; ev<10000;ev++) {");
   t->DrawText(3,7.2,"   event = new TEvent(ev);");
   t->SetTextColor(2);
   t->DrawText(3,6.4,"   tree.Fill();");
   t->SetTextColor(1);
   t->DrawText(3,5.6,"   delete event;");
   t->DrawText(3,4.8,"}");
   t->SetTextColor(4);
   t->DrawText(3,3.7,"dst.Close();");

   Signe(slide);
}
