void session()
{
//=========Macro describing a ROOT session to analyze a Tree

   char *slide="session";
   InitCanvas(slide);

   ptit = new TPaveLabel(4,22.5,16,23.8,"Interactive ROOT sessions:  Examples");
   ptit->SetFillColor(41);
   ptit->Draw();

   ps1 = new TPaveText(1,15.5,19,21.5);
   ps1->SetFillColor(18);
   ps1->Draw();
   Float_t xroot = 2;
   Float_t xp    = 3.7;
   root = new TText();
   root->SetTextFont(72);
   root->SetTextSize(0.028);
   root->SetTextColor(4);
   root->DrawText(xroot,20.8,"Root >");
   root->DrawText(xroot,20.0,"Root >");
   root->DrawText(xroot,19.2,"Root >");
   root->DrawText(xroot,18.4,"Root >");
   root->DrawText(xroot,17.6,"Root >");
   root->DrawText(xroot,16.8,"Root >");
   root->DrawText(xroot,16.0,"Root >");
   t = new TText();
   t->SetTextFont(62);
   t->SetTextSize(0.028);
   t->SetTextColor(1);
   t->DrawText(xp,20.8,"TFile f1("demo.root")");
   t->DrawText(xp,20.0,"T.Draw("fPx")");
   t->DrawText(xp,19.2,"T.Draw("fCalor.GetTotalEnergy()","fNtrack<500")");
   t->DrawText(xp,18.4,"TEvent *event = 0");
   t->DrawText(xp,17.6,"T.GetBranch("event")->SetAddress(@&event)");
   t->DrawText(xp,16.8,"T.GetEvent(4567)");
   t->DrawText(xp,16.0,"event->Draw()");

   root->DrawText(xroot,14.5,"Root >");
   t->SetTextColor(2);
   t->DrawText(xp,14.5,".x analysis.C(645)");
   t->SetTextColor(1);
   ps2 = new TPaveText(1,1.0,19,14);
   ps2->SetFillColor(18);
   ps2->Draw();
   Float_t xf = xroot + 0.7;
   Float_t y  = 13.4;
   Float_t dy = 0.64;
   t->SetTextColor(6);
   t->DrawText(xroot,y,"void analysis(Int_t maxtracks=500) {");
   t->SetTextColor(1);
   y -= 0.5*dy;
   y -= dy; t->DrawText(xf,y,"TFile *f1 = new TFile("demo.root");");
   y -= dy; t->DrawText(xf,y,"TH1F *hpt = new TH1F("hpt","pt_distribution",100,0,50);");
   y -= dy; t->DrawText(xf,y,"TTree *T = (TTree*)f1->Get("T");");
   y -= dy; t->DrawText(xf,y,"TEvent *event = 0;");
   y -= dy; t->DrawText(xf,y,"T->GetBranch("event")->SetAddress(@&event);");
   y -= dy; t->DrawText(xf,y,"Int_t nevents = T->GetEntries();");
   y -= 0.5*dy;
   t->SetTextColor(4);
   y -= dy; t->DrawText(xf,y,"for (Int_t ev=0;ev<nevents;ev++) {");
   Float_t yloopev = y+0.2;
   t->SetTextColor(1);
   y -= dy; t->DrawText(xf,y,"    T->GetEvent(ev);");
   y -= dy; t->DrawText(xf,y,"    Int_t ntracks = event->GetNtracks();");
   y -= dy; t->DrawText(xf,y,"    if (ntracks < maxtracks) continue;");
   t->SetTextColor(4);
   y -= dy; t->DrawText(xf,y,"    for (Int_t t=0;t<ntracks;t++) {");
   Float_t yloopt = y+0.2;
   t->SetTextColor(1);
   y -= dy; t->DrawText(xf,y,"        TTrack *track = event->GetTrack(t);");
   y -= dy; t->DrawText(xf,y,"        hpt->Fill(track->GetPt());");
   t->SetTextColor(4);
   y -= dy; t->DrawText(xf,y,"    };");
   arrow = new TArrow();
   arrow->SetLineColor(4);
   arrow->SetLineWidth(4);
   arrow->DrawArrow(8,y,17,y,0.001,">");
   arrow->DrawArrow(17,y,17,yloopt,0.001,">");
   arrow->DrawArrow(17,yloopt,12,yloopt,0.01,"|>");
   y -= dy; t->DrawText(xf,y,"}");
   arrow->DrawArrow(4,y,18,y,0.001,">");
   arrow->DrawArrow(18,y,18,yloopev,0.001,">");
   arrow->DrawArrow(18,yloopev,12,yloopev,0.01,"|>");
   y -= 0.5*dy;
   t->SetTextColor(2);
   y -= dy; t->DrawText(xf,y,"hpt->Draw();");
   t->SetTextColor(6);
   y -= dy; t->DrawText(xroot,y,"}");

   Signe(slide);
}
