void InitCanvas(const char *name)
{
   gROOT->Reset();
   char filename[100];
   sprintf(filename,"ROOT slide: %s",name);
   TCanvas *c1 = new TCanvas("c1", filename,100,10,700,900);
   c1->Range(0,0,20,24);
   c1->SetFillColor(10);
   c1->SetBorderSize(2);
}
void Signe(const char *name)
{
//      Draw slide address and print postscript file

   c1->cd();
   char filename[100];
   sprintf(filename,"/user/brun/root/slides/chep97/%s.C",name);
   TText *sig = new TText(.2,.2,filename);
   sig->SetTextAlign(11);
   sig->SetTextFont(72);
   sig->SetTextSize(0.020);
   sig->Draw();

   c1->Update();

   sprintf(filename,"%s.ps",name);
   c1->Print(filename);
}
